Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.geometry/org.gvsig.fmap.geometry.api/src/main/java/org/gvsig/fmap/geom/GeometryLibrary.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.geometry/org.gvsig.fmap.geometry.api/src/main/java/org/gvsig/fmap/geom/GeometryLibrary.java	(revision 43984)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.geometry/org.gvsig.fmap.geometry.api/src/main/java/org/gvsig/fmap/geom/GeometryLibrary.java	(revision 43985)
@@ -41,15 +41,24 @@
  */
 public class GeometryLibrary extends AbstractLibrary {
 
+    @Override
     public void doRegistration() {
         registerAsAPI(GeometryLibrary.class);
         require(ToolsLibrary.class);
         require(ProjectionLibrary.class);
     }
 
+    @Override
     protected void doInitialize() throws LibraryException {
+        DataTypesManager dataTypesManager = ToolsLocator.getDataTypesManager();
+        dataTypesManager.addtype(DataTypes.GEOMETRY, "Geometry", "Geometry",
+            Geometry.class, null);
+        dataTypesManager.addtype(DataTypes.ENVELOPE, "Envelope", "Envelope",
+            Envelope.class, null);
+
     }
 
+    @Override
     protected void doPostInitialize() throws LibraryException {
         // Validate there is any implementation registered.
         if(! GeometryLocator.getInstance().exists(GeometryLocator.GEOMETRY_MANAGER_NAME)) {
@@ -57,11 +66,5 @@
                 GeometryLocator.GEOMETRY_MANAGER_NAME,
                 GeometryLocator.getInstance());
         }
-        DataTypesManager dataTypesManager = ToolsLocator.getDataTypesManager();
-        dataTypesManager.addtype(DataTypes.GEOMETRY, "Geometry", "Geometry",
-            Geometry.class, null);
-        dataTypesManager.addtype(DataTypes.ENVELOPE, "Envelope", "Envelope",
-            Envelope.class, null);
-
     }
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.framework/org.gvsig.andami/pom.xml
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.framework/org.gvsig.andami/pom.xml	(revision 43984)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.framework/org.gvsig.andami/pom.xml	(revision 43985)
@@ -163,8 +163,8 @@
             <groupId>org.gvsig</groupId>
             <artifactId>org.gvsig.about.api</artifactId>
             <scope>runtime</scope>
-        </dependency>
-        <dependency>
+        </dependency> 
+       <dependency>
             <groupId>org.gvsig</groupId>
             <artifactId>org.gvsig.about.impl</artifactId>
             <scope>runtime</scope>
@@ -378,16 +378,6 @@
             <scope>runtime</scope>
             <version>1.2.8</version>
         </dependency>
-        <dependency>
-            <groupId>org.gvsig</groupId>
-            <artifactId>org.gvsig.temporarystorage.lib.api</artifactId>
-            <scope>runtime</scope>
-        </dependency>
-        <dependency>
-            <groupId>org.gvsig</groupId>
-            <artifactId>org.gvsig.temporarystorage.lib.impl</artifactId>
-            <scope>runtime</scope>
-        </dependency>
         
     </dependencies>
 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/assembly/gvsig-plugin-package.xml
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/assembly/gvsig-plugin-package.xml	(revision 43984)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/src/main/assembly/gvsig-plugin-package.xml	(revision 43985)
@@ -61,7 +61,23 @@
         <include>joda-time:joda-time</include>
         <include>net.sf:sqljep</include>
 
-        <include>org.gvsig:org.gvsig.fmap.control</include>
+        <include>org.gvsig:org.gvsig.metadata.lib.basic.api</include>
+        <include>org.gvsig:org.gvsig.metadata.lib.basic.impl</include>
+        <include>org.gvsig:org.gvsig.metadata.swing.basic.api</include>
+        <include>org.gvsig:org.gvsig.metadata.swing.basic.impl</include>
+        
+        <include>org.gvsig:org.gvsig.timesupport.lib.api</include>
+        <include>org.gvsig:org.gvsig.timesupport.lib.impl</include>
+        <include>org.gvsig:org.gvsig.timesupport.swing.api</include>
+        <include>org.gvsig:org.gvsig.timesupport.swing.impl</include>
+
+        <include>org.gvsig:org.gvsig.expressionevaluator.lib.api</include>
+        <include>org.gvsig:org.gvsig.expressionevaluator.lib.impl</include>
+        <include>org.gvsig:org.gvsig.expressionevaluator.swing.api</include>
+        <include>org.gvsig:org.gvsig.expressionevaluator.swing.impl</include>
+
+        <include>org.gvsig:org.gvsig.tools.evaluator.sqljep</include>
+
         <include>org.gvsig:org.gvsig.fmap.dal.api</include>
         <include>org.gvsig:org.gvsig.fmap.dal.db.lib</include>
         <include>org.gvsig:org.gvsig.fmap.dal.db.jdbc</include>
@@ -70,25 +86,22 @@
         <include>org.gvsig:org.gvsig.fmap.dal.spi</include>
         <include>org.gvsig:org.gvsig.fmap.dal.swing.api</include>
         <include>org.gvsig:org.gvsig.fmap.dal.swing.impl</include>
+
+        <include>org.gvsig:org.gvsig.temporarystorage.lib.api</include>
+        <include>org.gvsig:org.gvsig.temporarystorage.lib.impl</include>
+
+        <include>org.gvsig:org.gvsig.symbology.lib.api</include>
+        <include>org.gvsig:org.gvsig.symbology.lib.impl</include>
+        <include>org.gvsig:org.gvsig.symbology.swing.api</include>
+        <include>org.gvsig:org.gvsig.symbology.swing.impl</include>
+        
         <include>org.gvsig:org.gvsig.fmap.mapcontext.api</include>
         <include>org.gvsig:org.gvsig.fmap.mapcontext.impl</include>
         
-        <include>org.gvsig:org.gvsig.metadata.lib.basic.api</include>
-        <include>org.gvsig:org.gvsig.metadata.lib.basic.impl</include>
-        <include>org.gvsig:org.gvsig.metadata.swing.basic.api</include>
-        <include>org.gvsig:org.gvsig.metadata.swing.basic.impl</include>
+        <include>org.gvsig:org.gvsig.fmap.control</include>
+
         <include>org.gvsig:org.gvsig.remoteclient</include>
-        <include>org.gvsig:org.gvsig.symbology.lib.api</include>
-        <include>org.gvsig:org.gvsig.symbology.lib.impl</include>
-        <include>org.gvsig:org.gvsig.symbology.swing.api</include>
-        <include>org.gvsig:org.gvsig.symbology.swing.impl</include>
-        <include>org.gvsig:org.gvsig.timesupport.lib.api</include>
-        <include>org.gvsig:org.gvsig.timesupport.lib.impl</include>
-        <include>org.gvsig:org.gvsig.timesupport.swing.api</include>
-        <include>org.gvsig:org.gvsig.timesupport.swing.impl</include>
-        <include>org.gvsig:org.gvsig.tools.evaluator.sqljep</include>
-        <include>org.gvsig:org.gvsig.expressionevaluator.lib.api</include>
-        <include>org.gvsig:org.gvsig.expressionevaluator.lib.impl</include>
+        
         <include>org.jpedal:jpedal_lgpl</include>
 
         <include>zql:zql</include>
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/pom.xml
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/pom.xml	(revision 43984)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.plugin/org.gvsig.app/org.gvsig.app.mainplugin/pom.xml	(revision 43985)
@@ -187,16 +187,6 @@
             <scope>compile</scope>
         </dependency>
         <dependency>
-            <groupId>org.gvsig</groupId>
-            <artifactId>org.gvsig.expressionevaluator.lib.api</artifactId>
-            <scope>compile</scope>
-        </dependency>
-        <dependency>
-            <groupId>org.gvsig</groupId>
-            <artifactId>org.gvsig.expressionevaluator.lib.impl</artifactId>
-            <scope>runtime</scope>
-        </dependency>
-        <dependency>
             <groupId>zql</groupId>
             <artifactId>zql</artifactId>
             <scope>compile</scope>
@@ -311,6 +301,36 @@
             <artifactId>org.gvsig.fmap.dal.db.jdbc</artifactId>
             <scope>runtime</scope>
         </dependency>
+        <dependency>
+            <groupId>org.gvsig</groupId>
+            <artifactId>org.gvsig.expressionevaluator.lib.api</artifactId>
+            <scope>compile</scope>
+        </dependency>
+        <dependency>
+            <groupId>org.gvsig</groupId>
+            <artifactId>org.gvsig.expressionevaluator.swing.api</artifactId>
+            <scope>runtime</scope>
+        </dependency>
+        <dependency>
+            <groupId>org.gvsig</groupId>
+            <artifactId>org.gvsig.expressionevaluator.lib.impl</artifactId>
+            <scope>runtime</scope>
+        </dependency>
+        <dependency>
+            <groupId>org.gvsig</groupId>
+            <artifactId>org.gvsig.expressionevaluator.swing.impl</artifactId>
+            <scope>compile</scope>
+        </dependency>
+        <dependency>
+            <groupId>org.gvsig</groupId>
+            <artifactId>org.gvsig.temporarystorage.lib.api</artifactId>
+            <scope>compile</scope>
+        </dependency>
+        <dependency>
+            <groupId>org.gvsig</groupId>
+            <artifactId>org.gvsig.temporarystorage.lib.impl</artifactId>
+            <scope>runtime</scope>
+        </dependency>
 
 
 